;------------------------------
; MCM: Sequential Consistency
; MCM constraints for program 
; 
;  [x] = 0 and [y] = 0
;  T1:          | T2:  
;    st [x],1   |   ld r1, [y]  
;    st [y],1   |   ld r2, [x]
;
;   P: r1 = 1 and r2 = 0
;-----------------------------

(set-option :produce-models true)

; Variable definitions - SSA variables
(declare-fun v_x_0     () (_ BitVec 8))
(declare-fun v_y_0     () (_ BitVec 8))
(declare-fun v_x_T1_1  () (_ BitVec 8))
(declare-fun v_y_T1_1  () (_ BitVec 8))
(declare-fun v_r2_T2_1 () (_ BitVec 8))
(declare-fun v_r1_T2_1 () (_ BitVec 8))

; Variable definitions for Pi-functions
(declare-fun pi_x_T2_1 () (_ BitVec 8))
(declare-fun pi_y_T2_1 () (_ BitVec 8))

; Variable definitions - Timestamps


; State update constraints


; Pi-functions


; Program order


; Property
(assert (and (= v_r1_T2_1 #x01) (= v_r2_T2_1 #x00)))

; Check
(check-sat)

; Model
; (get-model) ; get model if SAT
